#include "bussim_global.h"
#include <iostream>
#include <stdio.h>
#include <string>
#include <freeglut/freeglut.h>

using namespace std;

/*extern int TASTE_GEDRUECKT;
extern int AUTOMATIC_MODE;
extern class BUSSIM_NETWORK NET;
extern int BETRIEBSENDE;
extern int SHOW_INFRASTRUCTURE;
extern int SHOW_STOPS;
extern int SHOW_LINES;
extern double *DeltaT;
extern int GLOBAL_COUNTER;
*/

extern class BUSSIM_NETWORK NET;
//extern int argc;
//extern char **argv;

// the global variables that control the simulation
int GLOBAL_COUNTER = 0;
int TASTE_GEDRUECKT = 1;
int BETRIEBSENDE = 0;
int AUTOMATIC_MODE = 0;
int SHOW_INFRASTRUCTURE = 0;
int SHOW_STOPS = 0;
int SHOW_LINES = 1;
int SHOW_LINE_AGENDA = BUSSIM_SHOW_LINE_AGENDA;
int SHOW_ACTIVE_VEHICLES = BUSSIM_SHOW_ACTIVE_VEHICLES;
int SHOW_MENUE = 1;
int SHOW_BUNCHES = BUSSIM_SHOW_BUNCHES;
int MOVE_CAMERA_POSITION = 0;
int MODIFY_ZOOM = 0;
int SHOW_NETWORKSTATISTICS = 0;
int SHOW_TOIS = BUSSIM_SHOW_TOI;    // from V 1.05
int SHOW_DIRECTION_INDICATORS = 0;  // from V 1.05
int SHOW_QUEUES = 0;                // from V 1.05

double MENUE_OFFSET_X = 0.0;
double MENUE_OFFSET_Y = 0.0;

void set_simulation_window(void)
{
    glutInitWindowSize(BUSSIM_WINDOWS_SIZE_X, BUSSIM_WINDOWS_SIZE_Y);
    glutCreateWindow("BuSSIM V 2.00");

    glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        glOrtho(-1, 1, -1, 1, -1, 1);

    //glMatrixMode(GL_MODELVIEW);
    //glLoadIdentity();

}

void set_callback_funcs(void)
{
    glutDisplayFunc(display);
    glutKeyboardFunc(tasten);
    glutTimerFunc(10, time_loop, 3 /* stupid value to pass to func. */);
    //glutMenuStatusFunc(update_line_list_menue);
}


// this is the main screen update method
void display(void)
{
    if( (TASTE_GEDRUECKT > 0))
        if( AUTOMATIC_MODE < 1)
            update_line_list_menue();

    if( (TASTE_GEDRUECKT > 0) || (AUTOMATIC_MODE > 0) )
    {

        if( MOVE_CAMERA_POSITION > 0 )
        {
            if( MOVE_CAMERA_POSITION == 1)
            {
                glMatrixMode(GL_MODELVIEW);
                glTranslatef(0,0.01,0);
                MENUE_OFFSET_Y += 0.01;
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
            }
            if( MOVE_CAMERA_POSITION == 2)
            {
                glMatrixMode(GL_MODELVIEW);
                glTranslatef(0.01,0,0);
                MENUE_OFFSET_X += 0.01;
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();

            }
            if( MOVE_CAMERA_POSITION == 3)
            {
                glMatrixMode(GL_MODELVIEW);
                glTranslatef(0,-0.01,0);
                MENUE_OFFSET_Y -= 0.01;
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
            }
            if( MOVE_CAMERA_POSITION == 4)
            {
                glMatrixMode(GL_MODELVIEW);
                glTranslatef(-0.01,0,0);
                MENUE_OFFSET_X -= 0.01;
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();

            }
            if( MOVE_CAMERA_POSITION == 5)
            {
                glMatrixMode(GL_MODELVIEW);
                MENUE_OFFSET_X = 0.0;
                MENUE_OFFSET_Y = 0.0;
                glLoadIdentity();
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();

            }
            MOVE_CAMERA_POSITION = 0;
        }
        if( MODIFY_ZOOM > 0 )
        {
            if( MODIFY_ZOOM == 7)
            {
                glPushName(12);
                glMatrixMode(GL_MODELVIEW);
                glScalef(0.95,0.95,1);
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
                glPushName(11);
            }
            if( MODIFY_ZOOM == 8)
            {
                glMatrixMode(GL_MODELVIEW);
                glScalef(1.05,1.05,1);
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
            }
            if( MODIFY_ZOOM == 9)
            {
                glMatrixMode(GL_MODELVIEW);
                glLoadIdentity();
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
            }
            MODIFY_ZOOM = 0;
        }

        // specify and set the title of the simulation window
        char WindowTitle[256];
        if( SHOW_NETWORKSTATISTICS > 0 )
        {
            sprintf(WindowTitle,"Statistics: %d stops - %d arcs - %d lines - %d vehicles",NET.POINTS,NET.ARCS,NET.LINES,NET.VEHICLES);
        }
        else
        {
            if( NET.BETRIEBS_ENDE < 1)
                sprintf(WindowTitle,"Menue: right mouse buttom - Current Sim Time=%.1f - Speed-Up Factor=%.1f - %ld stored events - %d bunches detected - x/y: %.2f/%.2f - %.2f\%% progress",NET.CURRENT_TIME,NET.SPEEDUP_FACTOR,NET.EVENTS, NET.DETECTED_BUNCHES, NET.x_factor, NET.y_factor, (100.0*(double)(NET.CURRENT_TIME)/(double)(BUSSIM_END_OF_DUTY)));
            else
                sprintf(WindowTitle,"Menue: right mouse buttom - Current Sim Time=%.1f - Speed-Up Factor=%.1f - %ld stored events - %d bunches detected - x/y: %.2f/%.2f - %.2f\%% progress (closing mode)",NET.CURRENT_TIME,NET.SPEEDUP_FACTOR,NET.EVENTS, NET.DETECTED_BUNCHES, NET.x_factor, NET.y_factor, 100.00);

        }
        // update displayed information
        glutSetWindowTitle(WindowTitle);

       //Clear all pixels
        glClear(GL_COLOR_BUFFER_BIT);

        //load the windows identity
        // glLoadName(12);

        //draw the landscape
        if( SHOW_TOIS > 0 )
            NET.draw_tois();

        // this is the global color (used e.g. for the text)
        glColor4f(0.0f,1.0f,0.0f,0.0f);

        // print the bunch points
        if( SHOW_BUNCHES > 0)
            NET.print_bunch_points();

        // draw the depot nodes
        if( SHOW_STOPS > 0 )
            NET.draw_depots();

        // draw service arcs
        //NET.draw_service_arcs();

        // set the standard line width
        glLineWidth((GLfloat)(1));

        // display the arcs
        for(int j=0 ; j < NET.ARCS ; j++)
        {
            glColor4f(0.0f, 1.0f, 0.0f, 0.0f);
            glLineWidth((GLfloat)(2));
            if( SHOW_INFRASTRUCTURE > 0)
                NET.ARC[j].print_on_screen();
            if( SHOW_QUEUES > 0 )
                NET.ARC[j].print_queue_on_screen(&NET);
            glLineWidth((GLfloat)(1));
            glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
        }

        // display the lines
        if( SHOW_LINES > 0 )
        {
            for(int j=0 ; j < NET.LINES ; j++)
            {
                glColor4f(NET.LINE[j].RED, NET.LINE[j].GREEN, NET.LINE[j].BLUE, 0.0f);
                glLineWidth((GLfloat)(5));
                NET.LINE[j].print_on_screen(&NET);
                if (SHOW_DIRECTION_INDICATORS > 0)
                    NET.LINE[j].print_on_screen_indicators(&NET);
                glLineWidth((GLfloat)(1));
                glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
            }
        }

        // set the vehicles visibility
        NET.set_visibility();

        // printing the menu
        /*
        if( SHOW_MENUE > 0)
        {
            glLoadName(11);
            glRasterPos2d(-0.9 - MENUE_OFFSET_X, BUSSIM_MENUE_POSITION - MENUE_OFFSET_Y);
            char SC[256];
            sprintf(SC,"<q> QUIT | <+> manual time step | <f>/<s> faster/slower | <a>/<m> automatic/manual mode | <i> show infrastructure | <L> show lines  | <S> show stops");
            unsigned char* ubufc = reinterpret_cast<unsigned char*>(SC);
            glutBitmapString(GLUT_BITMAP_HELVETICA_12, ubufc);

            glRasterPos2d(-0.9 - MENUE_OFFSET_X, BUSSIM_MENUE_POSITION-0.05 - MENUE_OFFSET_Y);
            char SC2[256];
            sprintf(SC2,"<A> show line agenda | <V> show list of active vehicles | <B> show bunch information | <M> disable/enable display of this menue");
            unsigned char* ubufc2 = reinterpret_cast<unsigned char*>(SC2);
            glutBitmapString(GLUT_BITMAP_HELVETICA_12, ubufc2);

            glRasterPos2d(-0.9 - MENUE_OFFSET_X, BUSSIM_MENUE_POSITION-0.1 - MENUE_OFFSET_Y);
            char SC3[256];
            sprintf(SC3,"<7>/<8> zoom in/ zoom out | <1> move up | <2> move right | <3> move down | <4> move left | <5> restore original view");
            unsigned char* ubufc3 = reinterpret_cast<unsigned char*>(SC3);
            glutBitmapString(GLUT_BITMAP_HELVETICA_12, ubufc3);
        }
        */

        // printed the number of detected bunches on the screen
        /*
        if( SHOW_BUNCHES > 0)
        {
            glColor4f(1.0f, 1.0f, 1.0f, 0.0f);
            glRasterPos2d(-0.9 - MENUE_OFFSET_X, -0.85 - MENUE_OFFSET_Y);
            char SB[256];
            sprintf(SB,"Detected Bunches %d ",NET.DETECTED_BUNCHES);
            unsigned char* ubufb = reinterpret_cast<unsigned char*>(SB);
            glutBitmapString(GLUT_BITMAP_HELVETICA_12, ubufb);
        }
        */
        /*
        glColor4f(1.0f, 1.0f, 1.0f, 0.0f);
        glRasterPos2d(-0.9, -0.90);
        char SB4[256];
        sprintf(SB4,"x / y: %.3f / %.3f ",NET.x_factor, NET.y_factor);
        unsigned char* ubufb4 = reinterpret_cast<unsigned char*>(SB4);
        glutBitmapString(GLUT_BITMAP_HELVETICA_12, ubufb4);
        */

        // check if additional vehicles are starting their daily work
        NET.start_rotations();

        // update the vehicle position
        for(int k=0 ; k < NET.VEHICLES ; k++)
        {
            NET.VEHICLE[k].update(&NET);
        }

        // print the stops if wanted
        glColor4f(0.0f, 0.0f, 0.0f, 0.0f);

        for(int j=0 ; j < NET.POINTS ; j++)
        {
            if( SHOW_STOPS > 0)
            {
                glColor4f(0.0f, 1.0f, 0.0f, 0.0f);
                NET.PT[j].print_on_screen_small();

            }
            if( SHOW_STOPS > 0 )
            {
                glColor4f(0.0f, 0.0f, 0.0f, 0.0f);
                NET.PT[j].print_label_on_screen();
            }
        }

        // print the line agenda
        if( SHOW_LINE_AGENDA > 0)
        for(int l=0 ; l < NET.LINES ; l++)
        {
            if( NET.LINE[l].type == BUSSIM_REGULARLINE )
            {
                glColor4f(NET.LINE[l].RED, NET.LINE[l].GREEN, NET.LINE[l].BLUE, 0.0f);
                glRasterPos2d(-0.9, +0.8 - 0.05*l);
                char S[256];
                sprintf(S,"%s (%d)",NET.LINE[l].LineName,NET.LINE[l].displayed);
                unsigned char* ubuf = reinterpret_cast<unsigned char*>(S);
                glutBitmapString(GLUT_BITMAP_HELVETICA_12, ubuf);
                glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
            }

        }

        // print the active vehicles of its current position

        for(int k=0 ; k < NET.VEHICLES ; k++)
        {
            if( NET.VEHICLE[k].VISIBLE > 0 )
            {
                glColor4f(NET.LINE[NET.VEHICLE[k].on_line].RED, NET.LINE[NET.VEHICLE[k].on_line].GREEN, NET.LINE[NET.VEHICLE[k].on_line].BLUE, 0.0f);
                NET.VEHICLE[k].print_on_screen(&NET);
                glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
            }
        }

        // start terminating the simulation
        if( NET.CURRENT_TIME >= BUSSIM_END_OF_DUTY )
            NET.BETRIEBS_ENDE = 1;

        // show the list of active vehicles
        if( SHOW_ACTIVE_VEHICLES > 0)
        {
            glColor4f(0.0f, 1.0f, 0.0f, 0.0f);
            NET.display_active_vehicles();
        }

        // update the graphic screen
        glFlush();

        //glutPostRedisplay();

        // check if the simulation has been completed
        if( NET.CURRENT_TIME > 0 )
            if( NET.VEHICLES > 0)
                if( NET.number_of_active_vehicles() == 0 )
                {
                    NET.print_event_list();
                    exit( EXIT_SUCCESS );
                }

        // reset keyboard cache
        TASTE_GEDRUECKT = 0;
    }
}


void tasten( unsigned char key, int x, int y )
{
    // here we receive and process the callback information from the keyboard
    switch( key ) {
    case 'q' :
        NET.print_event_list();
        exit( EXIT_SUCCESS );
    break;
    case '+':
        TASTE_GEDRUECKT = 1;
        NET.CURRENT_TIME += BUSSIM_TIME_STEP;
        GLOBAL_COUNTER++;
    break;
    case 'a':
        GLOBAL_COUNTER++;
        AUTOMATIC_MODE = 1;
    break;
    case 'm':
         GLOBAL_COUNTER++;
        AUTOMATIC_MODE = 0;
    break;
    case 'f':
        GLOBAL_COUNTER++;
        NET.SPEEDUP_FACTOR++;
    break;
    case 's':
       GLOBAL_COUNTER++;
        NET.SPEEDUP_FACTOR--;
        if( NET.SPEEDUP_FACTOR < 1 )
            NET.SPEEDUP_FACTOR = 1.0;
    break;
    case 'i':
        GLOBAL_COUNTER++;
        SHOW_INFRASTRUCTURE++;
        SHOW_INFRASTRUCTURE = SHOW_INFRASTRUCTURE % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'L':
        GLOBAL_COUNTER++;
        SHOW_LINES++;
        SHOW_LINES = SHOW_LINES % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'S':
        GLOBAL_COUNTER++;
        SHOW_STOPS++;
        SHOW_STOPS = SHOW_STOPS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'A':
        GLOBAL_COUNTER++;
        SHOW_LINE_AGENDA++;
        SHOW_LINE_AGENDA = SHOW_LINE_AGENDA % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'T':
        GLOBAL_COUNTER++;
        SHOW_TOIS++;
        SHOW_TOIS = SHOW_TOIS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'V':
        GLOBAL_COUNTER++;
        SHOW_ACTIVE_VEHICLES++;
        SHOW_ACTIVE_VEHICLES = SHOW_ACTIVE_VEHICLES % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'M':
        GLOBAL_COUNTER++;
        SHOW_MENUE++;
        SHOW_MENUE = SHOW_MENUE % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'B':
        GLOBAL_COUNTER++;
        SHOW_BUNCHES++;
        SHOW_BUNCHES = SHOW_BUNCHES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case '5':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 5;
        TASTE_GEDRUECKT = 1;
    break;
        case '1':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 1;
        TASTE_GEDRUECKT = 1;
    break;
        case '2':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 2;
        TASTE_GEDRUECKT = 1;
    break;
        case '3':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 3;
        TASTE_GEDRUECKT = 1;
    break;
        case '4':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 4;
        TASTE_GEDRUECKT = 1;
    break;
        case '7':
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 7;
        TASTE_GEDRUECKT = 1;
    break;
        case '8':
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 8;
        TASTE_GEDRUECKT = 1;
    break;
        case '9':
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 9;
        TASTE_GEDRUECKT = 1;
    break;
        case 'N':
        SHOW_NETWORKSTATISTICS++;
        SHOW_NETWORKSTATISTICS = SHOW_NETWORKSTATISTICS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'W':
        SHOW_QUEUES++;
        SHOW_QUEUES = SHOW_QUEUES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'D':
            if( SHOW_LINES > 0)
            {
                SHOW_DIRECTION_INDICATORS++;
                SHOW_DIRECTION_INDICATORS = SHOW_DIRECTION_INDICATORS % 2;
                TASTE_GEDRUECKT = 1;
            }
    }

    glutPostRedisplay();
}

void create_menue(void)
{
    glutCreateMenu(menu);
    glutAddMenuEntry("<q> quit",0);
    glutAddMenuEntry("<+> manual time step",1);
    glutAddMenuEntry("<a> enable automatic mode",2);
    glutAddMenuEntry("<m> stop automatic mode",3);
    glutAddMenuEntry("<f> increase speedup factor",4);
    glutAddMenuEntry("<s> increase speedup factor",5);
    glutAddMenuEntry("<i> show infrastructure",6);
    glutAddMenuEntry("<L> show lines",7);
    glutAddMenuEntry("<S> show stops",8);
    glutAddMenuEntry("<A> display line agenda",9);
    glutAddMenuEntry("<V> display list of active vehicles",10);
    glutAddMenuEntry("<B> print bunching points",12);
    glutAddMenuEntry("<N> switch information in window title",13);
    glutAddMenuEntry("<T> show tois",14);
    if( SHOW_LINES > 0 )
        glutAddMenuEntry("<D> show direction indicators",15);
    glutAddMenuEntry("<W> show queues on arcs",16);
    glutAddMenuEntry("<5> restore all view settings",20);
    glutAddMenuEntry("<1> move left",21);
    glutAddMenuEntry("<2> move up",22);
    glutAddMenuEntry("<3> move right",23);
    glutAddMenuEntry("<4> move down",24);

    glutAddMenuEntry("<7> zoom out",30);
    glutAddMenuEntry("<8> zoom in",31);
    glutAttachMenu(GLUT_RIGHT_BUTTON);

    // create the line menue to un/hide individual lines
    char TMP[256];
    glutCreateMenu(menu_a);
    for( int l=0 ; l < NET.LINES ; l++ )
    {
        if( NET.LINE[l].displayed > 0)
            sprintf(TMP,"hide line %d (%s)\n",NET.LINE[l].ID,NET.LINE[l].LineName);
        else
            sprintf(TMP,"unhide line %d (%s)\n",NET.LINE[l].ID,NET.LINE[l].LineName);
        glutAddMenuEntry(TMP,1000+l);
    }
    sprintf(TMP,"hide all %d lines\n",NET.LINES);
    glutAddMenuEntry(TMP,NET.LINES);

    sprintf(TMP,"unhide all %d lines\n",NET.LINES);
    glutAddMenuEntry(TMP,NET.LINES+1);
    glutAttachMenu(GLUT_MIDDLE_BUTTON);

    glutSetWindow(glutGetWindow());
}

void menu_a(int id)
{

    // un/hiding lines
    for( int l=0 ; l < NET.LINES ; l++ )
    {
        if( id == 1000+l)
        {
            GLOBAL_COUNTER++;
            NET.LINE[l].displayed++;
            NET.LINE[l].displayed = NET.LINE[l].displayed % 2;

            TASTE_GEDRUECKT = 1;
            l = NET.LINES+1;
            //glutChangeToMenuEntry()
            //glutChangeToMenuEntry(l, "neu", id);
            //glutSetMenu(&this);
        }

    }
    if( id== NET.LINES )
    {
        // hide all lines
        for( int l=0 ; l < NET.LINES ; l++ )
            NET.LINE[l].displayed = 0;
    }
    if( id== NET.LINES+1 )
    {
        // unhide all lines
        for( int l=0 ; l < NET.LINES ; l++ )
            NET.LINE[l].displayed = 1;
    }
}

void menu(int id)
{
   switch(id)
   {

    case 0 :  // <q>
        NET.print_event_list();
        exit( EXIT_SUCCESS );
    break;
    case 1:   // <+>
        TASTE_GEDRUECKT = 1;
        NET.CURRENT_TIME += BUSSIM_TIME_STEP;
        GLOBAL_COUNTER++;
    break;
    case 2:   // <a>
        GLOBAL_COUNTER++;
        AUTOMATIC_MODE = 1;
    break;
    case 3:   // <m>
         GLOBAL_COUNTER++;
        AUTOMATIC_MODE = 0;
    break;
    case 4:   // <f>
        GLOBAL_COUNTER++;
        NET.SPEEDUP_FACTOR++;
    break;
    case 5:   // <s>
       GLOBAL_COUNTER++;
        NET.SPEEDUP_FACTOR--;
        if( NET.SPEEDUP_FACTOR < 1 )
            NET.SPEEDUP_FACTOR = 1.0;
    break;
    case 6:   // <i>
        GLOBAL_COUNTER++;
        SHOW_INFRASTRUCTURE++;
        SHOW_INFRASTRUCTURE = SHOW_INFRASTRUCTURE % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 7:   // <L>
        GLOBAL_COUNTER++;
        SHOW_LINES++;
        SHOW_LINES = SHOW_LINES % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 8:   // <S>
        GLOBAL_COUNTER++;
        SHOW_STOPS++;
        SHOW_STOPS = SHOW_STOPS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 9:   // <A>
        GLOBAL_COUNTER++;
        SHOW_LINE_AGENDA++;
        SHOW_LINE_AGENDA = SHOW_LINE_AGENDA % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 10:   // <V>
        GLOBAL_COUNTER++;
        SHOW_ACTIVE_VEHICLES++;
        SHOW_ACTIVE_VEHICLES = SHOW_ACTIVE_VEHICLES % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 11:   // <M>
        GLOBAL_COUNTER++;
        SHOW_MENUE++;
        SHOW_MENUE = SHOW_MENUE % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 12: // <B>
        GLOBAL_COUNTER++;
        SHOW_BUNCHES++;
        SHOW_BUNCHES = SHOW_BUNCHES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 13:   // <N>
        GLOBAL_COUNTER++;
        SHOW_NETWORKSTATISTICS++;
        SHOW_NETWORKSTATISTICS = SHOW_NETWORKSTATISTICS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 14:   // <T>
        GLOBAL_COUNTER++;
        SHOW_TOIS++;
        SHOW_TOIS = SHOW_TOIS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 15:   // <T>
        GLOBAL_COUNTER++;
        SHOW_DIRECTION_INDICATORS++;
        SHOW_DIRECTION_INDICATORS = SHOW_DIRECTION_INDICATORS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 16:   // <T>
        GLOBAL_COUNTER++;
        SHOW_QUEUES++;
        SHOW_QUEUES = SHOW_QUEUES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 20:  // <5>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 5;
        TASTE_GEDRUECKT = 1;
    break;
        case 21:   // <1>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 1;
        TASTE_GEDRUECKT = 1;
    break;
        case 22:   // <2>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 23:   // <3>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 3;
        TASTE_GEDRUECKT = 1;
    break;
        case 24:   // <4>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 4;
        TASTE_GEDRUECKT = 1;
    break;
        case 30:   // <7>
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 7;
        TASTE_GEDRUECKT = 1;
    break;
        case 31:   // <8>
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 8;
        TASTE_GEDRUECKT = 1;
    break;
        case 32:   // <9>
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 9;
        TASTE_GEDRUECKT = 1;
    break;
   }

}

void time_loop(int passed_value)
{
    // this defines the automatic mode
    if( AUTOMATIC_MODE > 0 )
    {
        NET.CURRENT_TIME += BUSSIM_TIME_STEP;
        GLOBAL_COUNTER++;

    }
    //glutPostRedisplay();
    glutTimerFunc(1000.0/NET.SPEEDUP_FACTOR, time_loop, 1);
    glutPostRedisplay();
}

void update_line_list_menue()
{
    char TMP[256];

    int men;
    men = glutGetMenu();
    for( int l=0 ; l < NET.LINES ; l++ )
    {
        if( NET.LINE[l].displayed > 0)
            sprintf(TMP,"hide line %d (%s)\n",NET.LINE[l].ID,NET.LINE[l].LineName);
        else
            sprintf(TMP,"unhide line %d (%s)\n",NET.LINE[l].ID,NET.LINE[l].LineName);
        //glutAddMenuEntry(TMP,1000+l);
        glutChangeToMenuEntry(1+l,TMP,1000+l);

    }
    //glut
    glutSetMenu(men);
}
